<?php
  class Smarty_Cache_Mysql {
    
    protected $dbh;
    
    protected $nameSpace = "";
    
    function __construct($dbh) {
      $this->dbh = $dbh;
    }
    
    function setNameSpace($nameSpace) {
      $this->nameSpace = $nameSpace;
    }
    
    function handler($action, &$smarty_obj, &$cache_content, $tpl_file=null, $cache_id=null, $compile_id=null, $exp_time=null) {
  
      if(empty($this->dbh)) {
          $smarty_obj->_trigger_error_msg('cache_handler: could not connect to database');
          return false;
      }
      
      // create unique cache id
      $CacheID = md5($tpl_file.$cache_id.$compile_id);
  
      switch ($action) {
          case 'read':
              // read cache from database
              $results = mysql_query("select CacheContents from CACHE_PAGES where NameSpace LIKE '".mysql_real_escape_string($this->nameSpace)."' AND CacheID='$CacheID' AND `expire`>NOW() LIMIT 0,1 ", $this->dbh);
              if(!$results) {
                  $smarty_obj->_trigger_error_msg('cache_handler: query failed.');
              }
              $row = mysql_fetch_array($results,MYSQL_ASSOC);
  
              if($use_gzip && function_exists('gzuncompress')) {
                  $cache_content = gzuncompress($row['CacheContents']);
              } else {
                  $cache_content = $row['CacheContents'];
              }
              $return = $results;
              break;
          case 'write':
              // save cache to database
  
              if($use_gzip && function_exists("gzcompress")) {
                  // compress the contents for storage efficiency
                  $contents = gzcompress($cache_content);
              } else {
                  $contents = $cache_content;
              }
              $results = mysql_query("replace into CACHE_PAGES values(
                              '$CacheID',
                              '".mysql_real_escape_string($this->nameSpace)."',
                              ".(!empty($cache_id)?"'".mysql_real_escape_string($cache_id)."'":"NULL").",
                              '".addslashes($contents)."',
                              ".(!empty($exp_time)?"'".mysql_real_escape_string(date("Y-m-d H:i:s",$exp_time))."'":"NULL").")
                          ",$this->dbh);
              if(!$results) {
                  $smarty_obj->_trigger_error_msg('cache_handler: query failed.');
              }
              $return = $results;
              break;
          case 'clear':
              // clear cache info
              if(empty($cache_id) && empty($compile_id) && empty($tpl_file)) {
                  // clear them all
                  $results = mysql_query("delete from CACHE_PAGES WHERE NameSpace LIKE '".mysql_real_escape_string($this->nameSpace)."' ",$this->dbh);
              } elseif(!empty($cache_id) && empty($tpl_file)) {
                  //clear group
                  $results = mysql_query("delete from CACHE_PAGES where NameSpace LIKE '".mysql_real_escape_string($this->nameSpace)."' AND CacheGroup LIKE '".mysql_real_escape_string($cache_id)."%'",$this->dbh);
              } else {
                  $results = mysql_query("delete from CACHE_PAGES where NameSpace LIKE '".mysql_real_escape_string($this->nameSpace)."' AND CacheID='$CacheID'",$this->dbh);
              }
              if(!$results) {
                  $smarty_obj->_trigger_error_msg('cache_handler: query failed.');
              }
              $return = $results;
              break;
          default:
              // error, unknown action
              $smarty_obj->_trigger_error_msg("cache_handler: unknown action \"$action\"");
              $return = false;
              break;
      }
      
      return $return;
    }
    
  }
?>
